// 
// File:   unique.cc
// Author: cteam33
//
// Created on November 13, 2011, 11:52 AM
//

#include <stdlib.h>
#include <stack>
#include <cstring>
#include <stdio.h>

#define SIZE_POLE 200000000

unsigned char pole[SIZE_POLE];

int set(int i) {
	int div = i >> 3;
    unsigned char t = pole[div];
    int offset = i % 8;
    unsigned char h = 0x1;
    h = h << offset;
    
    int old = t & h;
    
    pole[div] = t | h;
    
    return old;
}

void unset(int i) {    
    
}


//
// 
//
int main(int argc, char** argv) {
    int m, q;
    int input[1100000];
    
    for (;;) {
        scanf("%i %i\n", &m, &q);
        
        if (m == 0 && q == 0) {
            return 0;            
        }

        for (int i = 0; i < m; i++) {
            scanf("%i\n", input + i); 
        }

        for (int i = 0; i < q; i++) {
            int a, b;
            scanf("%i %i\n", &a, &b);
		
	

            bool found = false;

		 for (int j = a - 1; j <= b - 1; j++) {
			 int k = input[j];	
			 pole[k >> 3] = 0x0;
		 }
		
            for (int j = a - 1; j <= b - 1; j++) {
		    
		    int c = input[j];
		    
		    int div = c >> 3;
		    unsigned char t = pole[div];
		    int offset = c % 8;
		    unsigned char h = 0x1;
		    h = h << offset;
		    
		    int old = t & h;
    
			pole[div] = t | h;
		    

                if (old) {
                    printf("%i\n", input[j]);
                    found = true;
                    break;
                }
            }

            if (!found) {
                printf("OK\n");
            }
        }
        
        scanf("\n");
        printf("\n");
    }
    
    return 0;
}

